﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using System.Runtime.InteropServices;   // For the DllImport of AIO167 Driver API


namespace AIOPC104Net
{
    public class AIOPC104
    {
        // Prototype AIO167.dll data and functions in managed C# for Dot Net (PC104 cards)
        // Using C# data types and default marshaling of unmanaged code

        [DllImport("AIO167.DLL", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern UInt32 GetNumCards();

        [DllImport("AIO167.DLL", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern UInt32 QueryCardID(UInt32 CardNum, out UInt32 pDeviceID);

        [DllImport("AIO167.DLL", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern UInt32 QueryCardBase(UInt32 CardNum, out UInt32 pBase);

        [DllImport("AIO167.DLL", SetLastError = true, CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern UInt32 WaitForIRQ(UInt32 CardNum);
        
        [DllImport("AIO167.DLL", SetLastError = true, CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern UInt32 COSWaitForIRQ(UInt32 CardNum, Int32 DataBytes, [In, Out] UInt16[] pData); // ref Void ???

        [DllImport("AIO167.DLL", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern UInt32 RelInPortStringW(UInt32 CardNum, UInt32 Offset, UInt32 Words, [In, Out] UInt16[] pData);

        [DllImport("AIO167.DLL", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern UInt32 InPortStringW(UInt32 Address, UInt32 Words, [In, Out] UInt16[] pData);
        
        /*
        // Dev for reference strings:
        // QueryDeviceInfo() String Name version :
        public static UInt32 QueryCardInfo(Int32 CardNum, out UInt32 pDeviceID, out UInt32 pBase, out UInt32 pNameSize, out String Name)
        {
            UInt32 Status;
            UInt32 NameSize = 256; // must pass this in by reference if you want name to be modified

            Char[] charName = new Char[NameSize];
            Status = QueryCardInfo(CardNum, out pDeviceID, out pBase, out NameSize, charName);

            Name = new String(charName, 0, (Int32)NameSize);
            pNameSize = NameSize;
            return Status;
        }
        */

        // In/Out Port functions:
        [DllImport("AIO167.DLL", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern UInt16 InPortB(UInt32 Port);
        [DllImport("AIO167.DLL", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern UInt16 OutPortB(UInt32 Port, Byte Value);

        [DllImport("AIO167.DLL", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern UInt16 InPort(UInt32 Port);
        [DllImport("AIO167.DLL", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern UInt16 OutPort(UInt32 Port, UInt16 Value);

        [DllImport("AIO167.DLL", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern UInt32 InPortL(UInt32 Port);
        [DllImport("AIO167.DLL", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern UInt16 OutPortL(UInt32 Port, UInt32 Value);
        [DllImport("AIO167.DLL", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern UInt32 InPortDWord(UInt32 Port);
        [DllImport("AIO167.DLL", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern UInt16 OutPortDWord(UInt32 Port, UInt32 Value);

        [DllImport("AIO167.DLL", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern UInt16 RelInPortB(Int32 CardNum, UInt32 Port);
        [DllImport("AIO167.DLL", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern UInt16 RelOutPortB(Int32 CardNum, UInt32 Port, Byte Value);

        [DllImport("AIO167.DLL", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern UInt16 RelInPort(Int32 CardNum, UInt32 Port);
        [DllImport("AIO167.DLL", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern UInt16 RelOutPort(Int32 CardNum, UInt32 Port, UInt16 Value);

        [DllImport("AIO167.DLL", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern UInt32 RelInPortL(Int32 CardNum, UInt32 Port);
        [DllImport("AIO167.DLL", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern UInt16 RelOutPortL(Int32 CardNum, UInt32 Port, UInt32 Value);
        [DllImport("AIO167.DLL", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern UInt32 RelInPortDWord(Int32 CardNum, UInt32 Port);
        [DllImport("AIO167.DLL", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern UInt16 RelOutPortDWord(Int32 CardNum, UInt32 Port, UInt32 Value);

    }
}
